package application;

import outils.Liste;
import outils.ListeChainee;
import outils.Test;
import outils.TestChaineDeLongueur4;
import outils.TestToujoursVrai;

public class EssaiParcoursListeChainee {
	private static void affichageDElementsDeLongueur4(Liste<String> lst) {
		for(String s : lst) {
			if (s.length() == 4)
				System.out.println(s);
		}
	}
	private static void affichageSi(Liste<String> lst, Test<String> test) {
		for(String s : lst) {
			if (test.reussitPour(s))
				System.out.println(s);
		}
	}
	public static void main(String arg[]) {
		ListeChainee<String> lst;
		lst = new ListeChainee<String>();
		lst.ajoute("un");
		lst.ajoute("deux");
		lst.ajoute("trois");
		lst.ajoute("quatre");
		lst.ajoute("cinq");
		lst.ajoute("six");
		lst.ajoute("sept");
//parcours avec for-each et affichage de toutes les chaines de caractères
		System.out.println("*** affichage de toutes les chaines ***");
		for(String s : lst) System.out.println(s);
		System.out.println("*** encore une fois avec test toujours vrai ***");
		affichageSi(lst, new TestToujoursVrai<String>());
//parcours avec for-each et affichage des chaines de caractères de longueur 4
		System.out.println("*** affichage des chaines de longueur 4 ***");
		System.out.println("*** avec test effectué dans for-each ***");
		affichageDElementsDeLongueur4(lst);
		System.out.println("*** par appel de sous-programme avec instance de classe nommée de test ***");
		affichageSi(lst, new TestChaineDeLongueur4());
		System.out.println("*** par appel de sous-programme avec instance de classe anonyme ***");
		affichageSi(lst, new Test<String>() {
			public boolean reussitPour(String s) { return s.length() == 4; }
		});
		System.out.println("*** par appel de sous-programme avec expression anonyme ***");
		affichageSi(lst, s -> s.length() == 4);
	}
}
