package temps;

import java.util.StringTokenizer;

public class HeureV1 implements Heure {
	private int h, m;
	public HeureV1() {
		h = 12;
		m = 0;
	}
	private void initialise(int heures, int minutes)
	throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
		if (heures >= 0 && heures < 24)
			h = heures;
		else
			throw new MauvaiseValeurDesHeures(heures);
		if (minutes >= 0 && minutes < 60)
			m = minutes;
		else
			throw new MauvaiseValeurDesMinutes(minutes);
	}
	public HeureV1(int heures, int minutes) 
	throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
		initialise(heures, minutes);
	}
	public HeureV1(String texte) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes{
		if (texte.matches("^[0-9]{1,2}:[0-9]{2}$")) {
			// inutile de tester st.hasMoreTokens()
			StringTokenizer st = new StringTokenizer(texte, ":");
			int heures, minutes;
			heures = Integer.parseInt(st.nextToken()); //inutile d'attraper NumberFormatException
			minutes = Integer.parseInt(st.nextToken());
			initialise(heures, minutes);
		} else {
			throw new MauvaisFormatDHeure(texte);
		}
	}
	public int heures() {
		return h;
	}
	public int minutes() {
		return m;
	}
	public void minutesPlus1() {
		m++;
		if (m == 60) {
			m = 0;
			heuresPlus1();
		}
	}
	public void minutesMoins1() {
		m--;
		if (m == -1) {
			m = 59;
			heuresMoins1();
		}
	}
	public void heuresPlus1() {
		h++;
		if (h == 24)
			h = 0;
	}
	public void heuresMoins1() {
		h--;
		if (h < 0)
			h = 23;
	}
	public String toString() {
		return String.format("%02d:%02d", h, m);
	}
}
