package temps;

import java.util.StringTokenizer;

public class HeureV2 implements Heure {
	private short m;
	public HeureV2() {
		m = 720;
	}
	private void initialise(int heures, int minutes)
	throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
		if (heures < 0 || heures > 23)
			throw new MauvaiseValeurDesHeures(heures);
		if (minutes < 0 || minutes > 59)
			throw new MauvaiseValeurDesMinutes(minutes);
		m = (short)(heures * 60 + minutes);
	}
	public HeureV2(int heures, int minutes) 
	throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
		initialise(heures, minutes);
	}
	public HeureV2(String texte)
	throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes{
		if (texte.matches("^[0-9]{1,2}:[0-9]{2}$")) {
			StringTokenizer st = new StringTokenizer(texte, ":");
			int heures, minutes;
			heures = Integer.parseInt(st.nextToken()); //inutile d'attraper NumberFormatException
			minutes = Integer.parseInt(st.nextToken());
			initialise(heures, minutes);
		} else {
			throw new MauvaisFormatDHeure(texte);
		}
	}
	public int heures() {
		return m / 60;
	}
	public int minutes() {
		return m % 60;
	}
	public void minutesPlus1() {
		if (m == 1439)
			m = 0;
		else
			m ++;
	}
	public void minutesMoins1() {
		if (m == 0)
			m = 1439;
		else
			m--;
	}
	public void heuresPlus1() {
		m += 60;
		if (m > 1440) m -= 1440;
	}
	public void heuresMoins1() {
		m -= 60;
		if (m < 0)	m += 1440; 
	}
	public String toString() {
		return String.format("%02d:%02d", heures(), minutes());
	}
}
